/**
 * @license
 * @version 0.9.2
 * The MIT License (MIT)
 * 
 * Copyright (c) 2015 Thomas Roch
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
define("router5",[],function(){var e=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||false;r.configurable=true;if("value"in r)r.writable=true;Object.defineProperty(e,r.key,r)}}return function(t,n,r){if(n)e(t.prototype,n);if(r)e(t,r);return t}}();function t(e,t){if(!(e instanceof t)){throw new TypeError("Cannot call a class as a function")}}var n=function n(e){return"("+(e?e.replace(/(^<|>$)/g,""):"[a-zA-Z0-9-_.~]+")+")"};var r=[{name:"url-parameter",pattern:/^:([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})(<(.+?)>)?/,regex:function a(e){return new RegExp(n(e[2]))}},{name:"url-parameter-splat",pattern:/^\*([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/,regex:/([^\?]*)/},{name:"url-parameter-matrix",pattern:/^\;([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})(<(.+?)>)?/,regex:function a(e){return new RegExp(";"+e[1]+"="+n(e[2]))}},{name:"query-parameter",pattern:/^(?:\?|&)(?:\:)?([a-zA-Z0-9-_]*[a-zA-Z0-9]{1})/},{name:"delimiter",pattern:/^(\/|\?)/,regex:function a(e){return new RegExp("\\"+e[0])}},{name:"sub-delimiter",pattern:/^(\!|\&|\-|_|\.|;)/,regex:function a(e){return new RegExp(e[0])}},{name:"fragment",pattern:/^([0-9a-zA-Z]+?)/,regex:function a(e){return new RegExp(e[0])}}];var i=function i(e){var t=arguments.length<=1||arguments[1]===undefined?[]:arguments[1];var n=r.some(function(n){var r=e.match(n.pattern);if(!r)return false;t.push({type:n.name,match:r[0],val:r.slice(1,2),otherVal:r.slice(2),regex:n.regex instanceof Function?n.regex(r):n.regex});if(r[0].length<e.length)t=i(e.substr(r[0].length),t);return true});if(!n){throw new Error("Could not parse path.")}return t};var u=function u(e,t){if(!t)return e;return e.replace(/\\\/$/,"")+"(?:\\/)?"};var s=function s(e,t){var n=arguments.length<=2||arguments[2]===undefined?"":arguments[2];var r=e[t];if(r===undefined)e[t]=n;else e[t]=Array.isArray(r)?r.concat(n):[r,n];return e};var o=function o(e){var t=e.split("?")[1];if(!t)return{};return t.split("&").map(function(e){return e.split("=")}).reduce(function(e,t){return s(e,t[0],t[1])},{})};var l=function l(e){return e!==undefined&&e!==null&&e!==""?"="+e:""};var f=function f(e,t){return Array.isArray(t)?t.map(function(t){return f(e,t)}).join("&"):e+l(t)};var h=function(){e(l,null,[{key:"createPath",value:function r(e){return new l(e)}},{key:"serialise",value:function a(e,t){return f(e,t)}}]);function l(e){t(this,l);if(!e)throw new Error("Please supply a path");this.path=e;this.tokens=i(e);this.hasUrlParams=this.tokens.filter(function(e){return/^url-parameter/.test(e.type)}).length>0;this.hasSpatParam=this.tokens.filter(function(e){return/splat$/.test(e.type)}).length>0;this.hasMatrixParams=this.tokens.filter(function(e){return/matrix$/.test(e.type)}).length>0;this.hasQueryParams=this.tokens.filter(function(e){return e.type==="query-parameter"}).length>0;this.urlParams=!this.hasUrlParams?[]:this.tokens.filter(function(e){return/^url-parameter/.test(e.type)}).map(function(e){return e.val.slice(0,1)}).reduce(function(e,t){return e.concat(t)});this.queryParams=!this.hasQueryParams?[]:this.tokens.filter(function(e){return e.type==="query-parameter"}).map(function(e){return e.val}).reduce(function(e,t){return e.concat(t)});this.params=this.urlParams.concat(this.queryParams);this.source=this.tokens.filter(function(e){return e.regex!==undefined}).map(function(e){return e.regex.source}).join("")}e(l,[{key:"_urlMatch",value:function h(e,t){var n=this;var r=e.match(t);if(!r)return null;else if(!this.urlParams.length)return{};return r.slice(1,this.urlParams.length+1).reduce(function(e,t,r){e[n.urlParams[r]]=t;return e},{})}},{key:"match",value:function c(e){var t=this;var n=arguments.length<=1||arguments[1]===undefined?0:arguments[1];var r=u(this.source,n);var a=this._urlMatch(e,new RegExp("^"+r+(this.hasQueryParams?"\\?.*$":"$")));if(!a||!this.hasQueryParams)return a;var i=o(e);var s=Object.keys(i).filter(function(e){return t.queryParams.indexOf(e)===-1});if(s.length===0){Object.keys(i).forEach(function(e){return a[e]=i[e]});return a}return null}},{key:"partialMatch",value:function v(e){var t=this;var n=arguments.length<=1||arguments[1]===undefined?0:arguments[1];var r=u(this.source,n);var a=this._urlMatch(e,new RegExp("^"+r));if(!a)return a;if(!this.hasQueryParams)return a;var i=o(e);Object.keys(i).filter(function(e){return t.queryParams.indexOf(e)>=0}).forEach(function(e){return s(a,e,i[e])});return a}},{key:"build",value:function m(){var e=arguments.length<=0||arguments[0]===undefined?{}:arguments[0];var t=arguments.length<=1||arguments[1]===undefined?{ignoreConstraints:false,ignoreSearch:false}:arguments[1];if(this.urlParams.some(function(t){return e[t]===undefined}))throw new Error("Missing parameters");if(!t.ignoreConstraints){var r=this.tokens.filter(function(e){return/^url-parameter/.test(e.type)&&!/-splat$/.test(e.type)}).every(function(t){return new RegExp("^"+n(t.otherVal[0])+"$").test(e[t.val])});if(!r)throw new Error("Some parameters are of invalid format")}var a=this.tokens.filter(function(e){return e.type!=="query-parameter"}).map(function(t){if(t.type==="url-parameter-matrix")return";"+t.val[0]+"="+e[t.val[0]];return/^url-parameter/.test(t.type)?e[t.val[0]]:t.match}).join("");if(t.ignoreSearch)return a;var i=this.queryParams.filter(function(t){return Object.keys(e).indexOf(t)!==-1}).map(function(t){return f(t,e[t])}).join("&");return a+(i?"?"+i:"")}}]);return l}();var c=function c(e){return e!==undefined&&e!==null&&e!==""};var v=function v(e,t){if(e.indexOf("?")===-1)return e;var n=e.split("?");var r=n[0];var a=n[1];var i=a.split("&").reduce(function(e,n){var r=n.split("=");var a=r[0];var i=r[1];if(t.indexOf(a)===-1)e[a]=i||"";return e},{});var u=Object.keys(i).map(function(e){return[e].concat(c(i[e])?i[e]:[])}).map(function(e){return e.join("=")}).join("&");return r+(u?"?"+u:"")};var m=function(){function n(){var e=arguments.length<=0||arguments[0]===undefined?"":arguments[0];var r=arguments.length<=1||arguments[1]===undefined?"":arguments[1];var a=arguments.length<=2||arguments[2]===undefined?[]:arguments[2];t(this,n);this.name=e;this.path=r;this.parser=r?new h(r):null;this.children=[];this.add(a);return this}e(n,[{key:"add",value:function r(e){var t=this;if(e===undefined||e===null)return;if(e instanceof Array){e.forEach(function(e){return t.add(e)});return}if(!(e instanceof n)&&!(e instanceof Object)){throw new Error("RouteNode.add() expects routes to be an Object or an instance of RouteNode.")}if(e instanceof Object){if(!e.name||!e.path){throw new Error("RouteNode.add() expects routes to have a name and a path defined.")}e=new n(e.name,e.path,e.children)}if(this.children.map(function(e){return e.name}).indexOf(e.name)!==-1){throw new Error('Alias "'+e.name+'" is already defined in route node')}if(this.children.map(function(e){return e.path}).indexOf(e.path)!==-1){throw new Error('Path "'+e.path+'" is already defined in route node')}var r=e.name.split(".");if(r.length===1){this.children.push(e);this.children.sort(function(e,t){if(e.path==="/")return 1;if(t.path==="/")return-1;var n=e.parser.hasUrlParams||e.parser.hasSpatParam;var r=t.parser.hasUrlParams||t.parser.hasSpatParam;if(!n&&!r){return e.path&&t.path?e.path.length<t.path.length?1:-1:0}if(n&&!r)return 1;if(!n&&r)return-1;if(!e.parser.hasSpatParam&&t.parser.hasSpatParam)return-1;if(!t.parser.hasSpatParam&&e.parser.hasSpatParam)return 1;var a=(e.path.match(/\//g)||[]).length;var i=(t.path.match(/\//g)||[]).length;if(a<i)return 1;return 0})}else{var a=this.getSegmentsByName(r.slice(0,-1).join("."));if(a){a[a.length-1].add(new n(r[r.length-1],e.path,e.children))}else{throw new Error("Could not add route named '"+e.name+"', parent is missing.")}}return this}},{key:"addNode",value:function a(e,t){this.add(new n(e,t));return this}},{key:"getSegmentsByName",value:function i(e){var t=function t(e,t){var n=t.filter(function(t){return t.name===e});return n.length?n[0]:undefined};var n=[];var r=e.split(".");var a=this.children;var i=r.every(function(e){var r=t(e,a);if(r){a=r.children;n.push(r);return true}return false});return i?n:null}},{key:"getSegmentsMatchingPath",value:function u(e){var t=arguments.length<=1||arguments[1]===undefined?false:arguments[1];var n=function n(e,r,a){var i=function(i){var u=e[i];var s=u.parser.partialMatch(r);var o=undefined,l=undefined;if(!s&&t){s=u.parser.match(r,true);o=""}else if(s){var f=u.parser.build(s,{ignoreSearch:true});o=v(r.replace(f,""),u.parser.queryParams);if(t&&o==="/"&&!/\/$/.test(f)){o=""}}if(s){a.push(u);Object.keys(s).forEach(function(e){return a.params[e]=s[e]});if(!o.length){return{v:a}}if(!u.children.length){return{v:null}}return{v:n(u.children,o,a)}}};for(var u in e){var s=i(u);if(typeof s==="object")return s.v}return null};var r=this.parser?[this]:this.children;var a=[];a.params={};return n(r,e,a)}},{key:"getPathFromSegments",value:function s(e){return e?e.map(function(e){return e.path}).join(""):null}},{key:"getPath",value:function o(e){return this.getPathFromSegments(this.getSegmentsByName(e))}},{key:"buildPathFromSegments",value:function l(e){var t=arguments.length<=1||arguments[1]===undefined?{}:arguments[1];if(!e)return null;var n=e.filter(function(e){return e.parser.hasQueryParams}).map(function(e){return e.parser.queryParams});var r=!n.length?null:n.reduce(function(e,t){return e.concat(t)}).filter(function(e){return Object.keys(t).indexOf(e)!==-1}).map(function(e){return h.serialise(e,t[e])}).join("&");return e.map(function(e){return e.parser.build(t,{ignoreSearch:true})}).join("")+(r?"?"+r:"")}},{key:"buildPath",value:function f(e){var t=arguments.length<=1||arguments[1]===undefined?{}:arguments[1];return this.buildPathFromSegments(this.getSegmentsByName(e),t)}},{key:"getMatchPathFromSegments",value:function c(e){if(!e||!e.length)return null;var t=e.map(function(e){return e.name}).join(".");var n=e.params;return{name:t,params:n}}},{key:"matchPath",value:function m(e){var t=arguments.length<=1||arguments[1]===undefined?false:arguments[1];return this.getMatchPathFromSegments(this.getSegmentsMatchingPath(e,t))}}]);return n}();var d={ROUTER_NOT_STARTED:"NOT_STARTED",ROUTER_ALREADY_STARTED:"ALREADY_STARTED",ROUTE_NOT_FOUND:"ROUTE_NOT_FOUND",SAME_STATES:"SAME_STATES",CANNOT_DEACTIVATE:"CANNOT_DEACTIVATE",CANNOT_ACTIVATE:"CANNOT_ACTIVATE",TRANSITION_ERR:"TRANSITION_ERR",NODE_LISTENER_ERR:"NODE_ERR",TRANSITION_CANCELLED:"CANCELLED"};function p(){var e=arguments;return function(){return e[0]}}var g=function g(){};var y=typeof window!=="undefined";var S=function S(){return window.location.pathname.replace(/\/$/,"")};var _=function _(e,t,n){return window.history.pushState(e,t,n)};var E=function E(e,t,n){return window.history.replaceState(e,t,n)};var w=function w(e){return window.addEventListener("popstate",e)};var k=function k(e){return window.removeEventListener("popstate",e)};var T=function T(e){var t=e.useHash?window.location.hash.replace(new RegExp("^#"+e.hashPrefix),""):window.location.pathname.replace(new RegExp("^"+e.base),"");return t+window.location.search};var A=function A(){return window.history.state};var P={};if(y){P={getBase:S,pushState:_,replaceState:E,addPopstateListener:w,removePopstateListener:k,getLocation:T,getState:A}}else{P={getBase:p(""),pushState:g,replaceState:g,addPopstateListener:g,removePopstateListener:g,getLocation:p(""),getState:p(null)}}function N(e,t,n,r,a){var i=arguments.length<=5||arguments[5]===undefined?false:arguments[5];e=e||function(){return false};var u=t||[];var s=function s(e){if(!u.length)return true;var t=u[0].length;var a=u[0](n,r,e);if(typeof a==="boolean"){e(a?null:true)}else if(a&&typeof a.then==="function"){a.then(function(){return e(null)},function(){return e(true)})}else if(t<3&&i){e(null)}return false};var o=function o(e){if(e)a(e);else{u=u.slice(1);l()}};var l=function l(){if(e()){a(null)}else{var t=s(o);if(t)a(null)}};l()}function b(e,t){var n=function n(e){return e.split(".").reduce(function(e,t){return e.concat(e.length?e[e.length-1]+"."+t:t)},[])};var r=undefined;var a=t?n(t.name):[];var i=n(e.name);var u=Math.min(a.length,i.length);if(t&&t.name===e.name)r=Math.max(u-1,0);else{for(r=0;r<u;r+=1){if(a[r]!==i[r])break}}var s=a.slice(r).reverse();var o=i.slice(r);var l=t&&r>0?a[r-1]:"";return{intersection:l,toDeactivate:s,toActivate:o}}function R(e,t,n,r){var a=false;var i=function i(){return a};var u=function u(){return a=true};var s=function s(e){return r(a?d.TRANSITION_CANCELLED:e)};var o=b(t,n);var l=o.intersection;var f=o.toDeactivate;var h=o.toActivate;var c=function c(t,n,r){var a=f.map(function(t){return e._cmps[t]}).filter(function(e){return e&&e.canDeactivate}).map(function(e){return e.canDeactivate});N(i,a,t,n,function(e){return r(e?d.CANNOT_DEACTIVATE:null)})};var v=function v(t,n,r){var a=h.map(function(t){return e._canAct[t]}).filter(function(e){return e});N(i,a,t,n,function(e){return r(e?d.CANNOT_ACTIVATE:null)})};var m=e._onTr;var p=function p(e,t,n){var r=[m];N(i,r,e,t,function(e){return n(e?d.TRANSITION_ERR:null)})};var g=e._cbs["^"+l];var y=function y(e,t,n){var r=g;N(i,r,e,t,function(e){return n(e?d.NODE_LISTENER_ERR:null)},true)};var S=(n?[c]:[]).concat(v).concat(m?p:[]).concat(g&&g.length?y:[]);N(i,S,t,n,s);return u}var O=Array.prototype.slice;var e=function(){function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||false;r.configurable=true;if("value"in r)r.writable=true;Object.defineProperty(e,r.key,r)}}return function(t,n,r){if(n)e(t.prototype,n);if(r)e(t,r);return t}}();function t(e,t){if(!(e instanceof t)){throw new TypeError("Cannot call a class as a function")}}var L=function L(e,t,n){return{name:e,params:t,path:n}};var x=function(){e(n,null,[{key:"ERR",value:d,enumerable:true},{key:"transitionPath",value:b,enumerable:true}]);function n(e){var r=this;var a=arguments.length<=1||arguments[1]===undefined?{}:arguments[1];t(this,n);this.started=false;this._onTr=null;this._cbs={};this._cmps={};this._canAct={};this.lastStateAttempt=null;this.lastKnownState=null;this.rootNode=e instanceof m?e:new m("","",e);this.options={useHash:false,hashPrefix:"",base:"",trailingSlash:0};Object.keys(a).forEach(function(e){return r.options[e]=a[e]});this._setBase();this.boundOnPopState=this.onPopState.bind(this)}e(n,[{key:"_setBase",value:function r(){if(this.options.useHash&&!this.options.base)this.options.base=P.getBase()}},{key:"setOption",value:function a(e,t){this.options[e]=t;if(e==="useHash")this._setBase();return this}},{key:"add",value:function i(e){this.rootNode.add(e);return this}},{key:"addNode",value:function u(e,t,n){this.rootNode.addNode(e,t);if(n)this._canAct[e]=n;return this}},{key:"onPopState",value:function s(e){var t=this;var n=!e.state||!e.state.name;var r=e.state||this.matchPath(this.getLocation());var a=this.options;if(!r){this.navigate(a.defaultRoute,a.defaultParams,{reload:true,replace:true});return}if(this.lastKnownState&&this.areStatesEqual(r,this.lastKnownState,false)){return}this._transition(r,this.lastKnownState,function(e,i){if(e){if(e===d.CANNOT_DEACTIVATE){var u=t.buildUrl(t.lastKnownState.name,t.lastKnownState.params);if(!n){t.updateBrowserState(r,u,true)}}else{t.navigate(a.defaultRoute,a.defaultParams,{reload:true,replace:true})}}else{t.updateBrowserState(i,t.buildUrl(i.name,i.params),n)}})}},{key:"onTransition",value:function o(e){this._onTr=e;return this}},{key:"start",value:function l(){var e=this;var t=[].concat(O.call(arguments));var n=t.slice(-1)[0];var r=n instanceof Function?n:null;var a=undefined,i=undefined;if(this.started){if(r)r(d.ROUTER_ALREADY_STARTED);return this}if(t.length>0){if(typeof t[0]==="string")a=t[0];if(typeof t[0]==="object")i=t[0]}this.started=true;var u=this.options;var s=function s(t,n){var a=arguments.length<=2||arguments[2]===undefined?true:arguments[2];P.addPopstateListener(e.boundOnPopState);if(r)r(t,n);if(t&&a)e._invokeListeners("$error",n,null,t)};if(!a&&!i)a=this.getLocation();if(!i){(function(){i=e.matchPath(a);var t=function t(){return e.navigate(u.defaultRoute,u.defaultParams,{replace:true},function(e,t){return s(e,t,false)})};if(i){e.lastStateAttempt=i;e._transition(e.lastStateAttempt,e.lastKnownState,function(n,r){if(!n){e.updateBrowserState(e.lastKnownState,e.buildUrl(i.name,i.params),true);s(null,r)}else if(u.defaultRoute)t();else s(n,null,false)})}else if(u.defaultRoute){t()}else{s(d.ROUTE_NOT_FOUND,null)}})()}else{this.lastKnownState=i;this.updateBrowserState(this.lastKnownState,this.buildUrl(i.name,i.params),true);s(null,i)}return this}},{key:"stop",value:function f(){if(!this.started)return this;this.lastKnownState=null;this.lastStateAttempt=null;this.started=false;P.removePopstateListener(this.boundOnPopState);return this}},{key:"getState",value:function h(){return this.lastKnownState}},{key:"isActive",value:function c(e){var t=arguments.length<=1||arguments[1]===undefined?{}:arguments[1];var n=arguments.length<=2||arguments[2]===undefined?false:arguments[2];var r=arguments.length<=3||arguments[3]===undefined?true:arguments[3];var a=this.getState();if(!a)return false;if(n||a.name===e){return this.areStatesEqual(L(e,t),a,r)}return this.areStatesDescendants(L(e,t),a)}},{key:"areStatesEqual",value:function v(e,t){var n=this;var r=arguments.length<=2||arguments[2]===undefined?true:arguments[2];if(e.name!==t.name)return false;var a=function a(e){return n.rootNode.getSegmentsByName(e).map(function(e){return e.parser[r?"urlParams":"params"]}).reduce(function(e,t){return e.concat(t)},[])};var i=a(e.name);var u=a(t.name);return i.length===u.length&&i.every(function(n){return e.params[n]===t.params[n]})}},{key:"areStatesDescendants",value:function p(e,t){var n=new RegExp("^"+e.name+"\\.(.*)$");if(!n.test(t.name))return false;return Object.keys(e.params).every(function(n){return e.params[n]===t.params[n]})}},{key:"_invokeListeners",value:function g(e){for(var t=arguments.length,n=Array(t>1?t-1:0),r=1;r<t;r++){n[r-1]=arguments[r]}(this._cbs[e]||[]).forEach(function(e){return e.apply(undefined,n)})}},{key:"_addListener",value:function y(e,t,n){var r=e.replace(/^(\*|\^|=)/,"");if(r&&!/^\$/.test(e)){var a=this.rootNode.getSegmentsByName(r);if(!a)console.warn("No route found for "+r+", listener might never be called!")}if(!this._cbs[e])this._cbs[e]=[];this._cbs[e]=(n?[]:this._cbs[e]).concat(t);return this}},{key:"_removeListener",value:function S(e,t){if(this._cbs[e])this._cbs[e]=this._cbs[e].filter(function(e){return e!==t});return this}},{key:"addListener",value:function _(e){return this._addListener("*",e)}},{key:"removeListener",value:function E(e){return this._removeListener("*",e)}},{key:"addNodeListener",value:function w(e,t){return this._addListener("^"+e,t,true)}},{key:"removeNodeListener",value:function k(e,t){this._cbs["^"+e]=[];return this}},{key:"addRouteListener",value:function T(e,t){return this._addListener("="+e,t)}},{key:"removeRouteListener",value:function A(e,t){return this._removeListener("="+e,t)}},{key:"onTransitionStart",value:function N(e){return this._addListener("$start",e)}},{key:"offTransitionStart",value:function x(e){return this._removeListener("$start",e)}},{key:"onTransitionCancel",value:function C(e){return this._addListener("$cancel",e)}},{key:"offTransitionCancel",value:function D(e){return this._removeListener("$cancel",e)}},{key:"onTransitionError",value:function j(e){return this._addListener("$error",e)}},{key:"offTransitionError",value:function U(e){return this._removeListener("$error",e)}},{key:"registerComponent",value:function $(e,t){if(this._cmps[e])console.warn("A component was alread registered for route node "+e+".");this._cmps[e]=t;return this}},{key:"deregisterComponent",value:function I(e){delete this._cmps[e]}},{key:"canActivate",value:function B(e,t){this._canAct[e]=t;return this}},{key:"getLocation",value:function K(){return P.getLocation(this.options)}},{key:"buildUrl",value:function M(e,t){return this._buildUrl(this.rootNode.buildPath(e,t))}},{key:"_buildUrl",value:function q(e){return this.options.base+(this.options.useHash?"#"+this.options.hashPrefix:"")+e}},{key:"buildPath",value:function F(e,t){return this.rootNode.buildPath(e,t)}},{key:"matchPath",value:function z(e){var t=this.rootNode.matchPath(e,this.options.trailingSlash);return t?L(t.name,t.params,e):null}},{key:"urlToPath",value:function Z(e){var t=e.match(/^(?:http|https)\:\/\/(?:[0-9a-z_\-\.\:]+?)(?=\/)(.*)$/);var n=t?t[1]:e;var r=n.match(/^(.*?)(#.*?)?(\?.*)?$/);if(!r)throw new Error("Could not parse url "+e);var a=r[1];var i=r[2];var u=r[3];var s=this.options;return(s.useHash?i.replace(new RegExp("^#"+s.hashPrefix),""):a.replace(new RegExp("^"+s.base),""))+(u||"")}},{key:"matchUrl",value:function V(e){return this.matchPath(this.urlToPath(e))}},{key:"_transition",value:function H(e,t,n){var r=this;if(this._tr)this._tr();this._invokeListeners("$start",e,t);var a=R(this,e,t,function(a){r._tr=null;if(a){if(a===d.TRANSITION_CANCELLED)r._invokeListeners("$cancel",e,t);else r._invokeListeners("$error",e,t,a);if(n)n(a);return}r.lastKnownState=e;r._invokeListeners("="+e.name,e,t);r._invokeListeners("*",e,t);if(n)n(null,e)});this._tr=a;return function(){return!a||a()}}},{key:"navigate",value:function Q(e,t,n,r){if(t===undefined)t={};var a=this;if(n===undefined)n={};if(!this.started){if(r)r(d.ROUTER_NOT_STARTED);return}if(!P.getState())n.replace=true;var i=this.buildPath(e,t);var u=this.buildUrl(e,t);if(!i){if(r)r(d.ROUTE_NOT_FOUND);this._invokeListeners("$error",null,this.lastKnownState,d.ROUTE_NOT_FOUND);return}var s=L(e,t,i);this.lastStateAttempt=s;var o=this.lastKnownState?this.areStatesEqual(this.lastKnownState,this.lastStateAttempt,false):false;if(o&&!n.reload){if(r)r(d.SAME_STATES);this._invokeListeners("$error",s,this.lastKnownState,d.SAME_STATES);return}return this._transition(s,o?null:this.lastKnownState,function(e,t){if(e){if(r)r(e);return}a.updateBrowserState(a.lastStateAttempt,u,n.replace);if(r)r(null,t)})}},{key:"updateBrowserState",value:function Y(e,t){var n=arguments.length<=2||arguments[2]===undefined?false:arguments[2];var r=arguments.length<=3||arguments[3]===undefined?"":arguments[3];P[n?"replaceState":"pushState"](e,r,t)}}]);return n}();return{RouteNode:m,Router5:x}});